/****************************************************************************
	SATDEMO.C

	This is an VERY QUICK AND DIRTY demo of the RR.DLL functions.

	(C) Copyright 1994, David A. Hoatson, KC6WYG. All Rights Reserved.
	(C) Copyright 1995-1996, Joe Holman, AD7D, ex-KA7LDN.  All Rights Reserved.

  Joe Holman email:	AD7D@amsat.org, ex- KA7LDN@amsat.org 

****************************************************************************/

#include <windows.h>
#include <mmsystem.h>
#include <stdlib.h>
#include <stdio.h>
#include "resource.h"
#include "satelite.h"



HANDLE	hInst;
HWND	hWndMain;

char	dbgStr[300];


WORD	wAzimuth;
WORD	wElevation;
DWORD	dwTxFreq;
DWORD	dwRxFreq;
DWORD	dwFlags;
DWORD	dwTxMode = RADIOMODE_LSB;
DWORD	dwRxMode = RADIOMODE_USB;
UINT	wDeviceID = 0;
UINT 	uiTimerID;

STATUS	Status;

void DisplayStatus( STATUS Status, char * szFunction ) {
	
	char szMessage[240];
	
	wsprintf( szMessage, "Returned %d  %s %s", 
					Status, 
					Status & STATUS_ELEVSTALLED ? "ELEV STALLED" : " ",
					Status & STATUS_AZIMSTALLED ? "AZIM STALLED" : " " );
	
	MessageBox( hWndMain, szMessage, szFunction, MB_OK | MB_ICONEXCLAMATION );

}

DWORD	dwModes[] = { RADIOMODE_FM, RADIOMODE_CW, RADIOMODE_USB, RADIOMODE_LSB };
			
void	ButtonMsgProc( HWND hWnd, WORD wID, WORD NotifyCode )	{


	BOOL bTranslated;
	char szBuffer[40];
	double fRxFreq, fTxFreq;
	WORD nCheckControl;
	
	switch( wID ) {
		
		case IDE_AZIM:
		case IDE_ELEV:
			break;

		case IDC_CONFIGURE_ROTORRADIO:

			//	Call the API that brings up the modal configuration dialog.
			//
			RotorRadioConfigure ( hWnd, hInst );

			RotorClose();
			RadioClose();

			//	Re-open the radio and rotor to read in the newly set parameters, if any.
			//

			// Open the rotor.
			//
			Status = RotorOpen();

			if( Status ) {

				DisplayStatus( Status, "SatDemo.Exe ERROR RotorOpen" );
				
			}

			//	Open the radio.  If no RX/TX defined, defaults to 2m uplink and 70cm downlink.
			//
			dwFlags = SATBAND_TX_144MHZ | SATBAND_RX_430MHZ;

			Status = RadioOpen( dwFlags );

			if( Status ) {

				DisplayStatus( Status, "SatDemo.Exe ERROR RadioOpen" );
			}
			
			//ButtonMsgProc( hWnd, IDC_GETMODE, 0 );
			//ButtonMsgProc( hWnd, IDC_GETFREQ, 0 );

			break;

		case IDC_SETPOS: 

			wAzimuth = GetDlgItemInt( hWnd, IDE_AZIM, &bTranslated, FALSE );
			wElevation = GetDlgItemInt( hWnd, IDE_ELEV, &bTranslated, FALSE );
			Status = RotorSetPosition( wAzimuth, wElevation, 0L );

			if( Status ) {

				DisplayStatus( Status, "SatDemo.Exe ERROR RotorSetPosition" );
			}
			
			break;

		case IDC_SETFREQ:
			
			GetDlgItemText( hWnd, IDE_RXFREQ, szBuffer, sizeof( szBuffer ) );
			fRxFreq = atof ( szBuffer );
			sprintf( szBuffer, "%f", fRxFreq );
			SetDlgItemText( hWnd, IDE_RXFREQ, szBuffer );
			dwRxFreq = (DWORD) (fRxFreq * 1000000);
			            
            GetDlgItemText( hWnd, IDE_TXFREQ, szBuffer, sizeof( szBuffer ) );
			fTxFreq = atof ( szBuffer );
			sprintf( szBuffer, "%f", fTxFreq );
			SetDlgItemText( hWnd, IDE_TXFREQ, szBuffer );
			dwTxFreq = (DWORD) (fTxFreq * 1000000);

			Status = RadioSetFrequency( dwRxFreq, dwTxFreq, 0 );
			if( Status ) {
				DisplayStatus( Status, "SatDemo.Exe ERROR RadioSetFrequency" );
			}
			        
			break;
			
			
		case IDC_GETMODE:
			
			Status = RadioGetMode( &dwRxMode, &dwTxMode );
			if( Status ) {
				DisplayStatus( Status, "SatDemo.Exe ERROR RadioGetMode" );
			}


			switch( dwRxMode ) {
				
				case RADIOMODE_FM:	nCheckControl = IDC_RX_FM;	break;
				case RADIOMODE_CW:	nCheckControl = IDC_RX_CW;	break;
				case RADIOMODE_USB:	nCheckControl = IDC_RX_USB;	break;
				case RADIOMODE_LSB:	nCheckControl = IDC_RX_LSB;	break;
			}

			CheckRadioButton( hWnd, IDC_RX_FM, IDC_RX_LSB, nCheckControl );


			switch( dwTxMode ) {
				
				case RADIOMODE_FM:	nCheckControl = IDC_TX_FM;	break;
				case RADIOMODE_CW:	nCheckControl = IDC_TX_CW;	break;
				case RADIOMODE_USB:	nCheckControl = IDC_TX_USB;	break;
				case RADIOMODE_LSB:	nCheckControl = IDC_TX_LSB;	break;
			}

			CheckRadioButton( hWnd, IDC_TX_FM, IDC_TX_LSB, nCheckControl );
			
			break;
			
		case IDC_SETMODE:


			Status = RadioSetMode( dwRxMode, dwTxMode, 0 );

			if( Status ) {
				DisplayStatus( Status, "SatDemo.Exe ERROR RadioSetMode" );
			}

			ButtonMsgProc ( hWnd, IDC_GETMODE, 0 );

			break;
			

		case IDC_RX_FM:
		case IDC_RX_CW:
		case IDC_RX_USB:
		case IDC_RX_LSB:

			dwRxMode = dwModes[ wID - IDC_RX_FM ];
			CheckRadioButton( hWnd, IDC_RX_FM, IDC_RX_LSB, wID );
			break;
			

		case IDC_TX_FM:
		case IDC_TX_CW:
		case IDC_TX_USB:
		case IDC_TX_LSB:

			dwTxMode = dwModes[ wID - IDC_TX_FM ];
			CheckRadioButton( hWnd, IDC_TX_FM, IDC_TX_LSB, wID );
			break;
		}
}

BOOL CALLBACK MainDlgProc( HWND hWnd, unsigned wMessage, WORD wParam, LONG lParam ) {

	switch(wMessage) {
		
		case WM_TIMER:

			{
			char 	szBuffer[140];
			STATUS 	StatusAnalog;
			WORD	wAzimuthAnalog, wElevationAnalog;
			
			Status 		 = RotorGetPosition       ( &wAzimuth,       &wElevation );
			StatusAnalog = RotorGetPositionAnalog ( &wAzimuthAnalog, &wElevationAnalog );


			wsprintf( szBuffer, "Azim:  %d  (%d%s)", 
					wAzimuth,
					Status,
					Status & STATUS_AZIMSTALLED ? " ASTL" : " OK" );

			SetDlgItemText( hWnd, IDE_AZIM_TXT, szBuffer );

			
			wsprintf( szBuffer, "Azim:  %d  (%d%s)", 
					wAzimuthAnalog,
					StatusAnalog,
					StatusAnalog & STATUS_AZIMSTALLED ? " ASTL" : " OK" );

			SetDlgItemText( hWnd, IDE_AZIM_TXT_A, szBuffer );



			wsprintf( szBuffer, "Elev:  %d  (%d%s)", 
					wElevation,
					Status,
					Status & STATUS_ELEVSTALLED ? " ESTL" : " OK" );
					
			SetDlgItemText( hWnd, IDE_ELEV_TXT, szBuffer );

			wsprintf( szBuffer, "Elev:  %d  (%d%s)", 
					wElevationAnalog,
					StatusAnalog,
					StatusAnalog & STATUS_ELEVSTALLED ? " ESTL" : " OK" );
					
			SetDlgItemText( hWnd, IDE_ELEV_TXT_A, szBuffer );



			RadioGetFrequency( &dwRxFreq, &dwTxFreq );
				
			wsprintf( szBuffer, "%d", dwRxFreq );
			SetDlgItemText( hWnd, IDE_FREQ_RX, szBuffer );
                        
            wsprintf( szBuffer, "%d", dwTxFreq );
			SetDlgItemText( hWnd, IDE_FREQ_TX, szBuffer );
		
            }

			break;

		case WM_INITDIALOG :
			
			return TRUE;

		case WM_COMMAND :

			if(!LOWORD(lParam))	{ // menu commands
				
			}
			else {

				ButtonMsgProc( hWnd, LOWORD(wParam), HIWORD( wParam ) );
			}
			break;

		case WM_SYSCOMMAND:

			switch(wParam & 0xFFF0) {
				
				case SC_CLOSE:

					KillTimer ( NULL, uiTimerID );

					Status = RotorClose();

					if( Status ) {

						DisplayStatus( Status, "SatDemo.Exe ERROR RotorClose" );
					}

					Status = RadioClose();

					if( Status ) {

						DisplayStatus( Status, "SatDemo.Exe ERROR RadioClose" );
					}

					PostQuitMessage(0);
					return TRUE;
				}

		default:
			return FALSE;
		}
	return FALSE;
}


int APIENTRY WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow) {
	
	MSG		msg;
	hInst = hInstance;		// Store the application instance handle


	// Open the rotor.
	//
	
	Status = RotorOpen();
	if( Status ) {

		DisplayStatus( Status, "SatDemo.Exe ERROR RotorOpen" );
		return FALSE;
	}

	//	Open the radio.  If no RX/TX defined, defaults to 2m uplink and 70cm downlink.
	//
	dwFlags = SATBAND_TX_144MHZ | SATBAND_RX_430MHZ;
	Status = RadioOpen( dwFlags );
	
	if( Status ) {

		DisplayStatus( Status, "SatDemo.Exe ERROR RadioOpen" );
		return FALSE;
	}


	hWndMain = CreateDialog( hInst, "Main", NULL, MainDlgProc );

	if( hWndMain == NULL ) {
		
		MessageBox( NULL, "CreateDialog Failed!", "SatDemo.Exe WinMain", MB_OK | MB_ICONEXCLAMATION );
		return FALSE;
	}

	//ButtonMsgProc( hWndMain, IDC_GETMODE, 0 );
	//ButtonMsgProc( hWndMain, IDC_GETFREQ, 0 );

	ShowWindow( hWndMain, nCmdShow );
	UpdateWindow( hWndMain );

	uiTimerID = SetTimer ( hWndMain, 0, 250, NULL );	// show the Az and El once every 1/4 second

	if ( uiTimerID == 0 ) {

	 	MessageBox ( NULL, "SetTimer FAILed", "Satdemo WinMain", MB_ICONHAND );
	}

	while( GetMessage( &msg, NULL, 0, 0 ) ) {
		
			
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}

	return( msg.wParam );
}
